clear all,close all,clc
% Process initial condition
u0=3;                  % initial input
F_in=3;                % inlet flow
h_sp=1;                % setpoint
h=1;                   % inital tank level
A=2000; 
K=1/A;
tau=0;
% PID controller 
Kp=2;
Ti=2000;
Td=0;
Tc=500;
Esum=0;
% Skogestad PI tuning
Kp=1/(K*(Tc+tau));
Ti=2*(Tc+tau);
% Level measurement and time-constant filter papameter
a=0.05;                % filter parameter
h_m=1;                 % level measurement
h_mf=1;                % filtered 

% Time sery
Endt=15000;
h_t=zeros(1,Endt);
T=linspace(0,Endt-1,Endt);
h_sp_t=ones(1,Endt);

for t=1:Endt
    R=-0+0*rand(1,1); % random noise between (-0.1:0.1)from uniform distribution
    h_m= h*(1+R);
    
    if t>=Endt/3;
        h_sp=1.5;  % step change of setpoint 
        h_sp_t(t)=1.5;
    end
   if t>=2*Endt/3;         % step change of inflow
        F_in=3.5;
       
    end
    e=h_sp-h_mf;           % error
    Esum=Esum+e;           % Integral term
    
  u=u0+Kp*e+Kp/Ti*Esum;    % controller update
  Dh=1/A*(F_in-u);
  h=h-Dh;                  % Process update
  h_t(t)=h;
  h_mf = (1-a)*h_mf+a*h_m; % filter update
 
end

plot(T,h_t)
hold on
plot(T,h_sp_t,'r--')



