clear all,close all,clc
%%Problem2 Based on the results of Problem 1, another for-loop was added. 
% Process initial condition
u0=3;                  % initial input
F_in=3;                % inlet flow
h_sp=1;                % setpoint
h=1;                   % inital tank level
A=2000; 
K=1/A;
tau=500;               % delay time

% PID controller 
Kp=4;
Ti=1000;
Esum=0;


% Time sery
Endt=10000;
h_t=zeros(1,Endt);
T=linspace(0,Endt-1,Endt);
h_sp_t=ones(1,Endt);
h_delay=ones(1,Endt);        %% delay array
for t=1:Endt
 
    if t>=Endt/3;
        h_sp=1.5;          % step change of setpoint 
        h_sp_t(t)=1.5;
    end
    e=h_sp-h;              % error
    Esum=Esum+e;           % Integral term 
    
    
  u=u0+Kp*e+Kp/Ti*Esum;    % controller update
  Dh=1/A*(F_in-u);
  
  h=h-Dh;                  % Process update
  h_t(t)=h;
 
   
end

%% Generate the Time-delay array
for t=1:Endt
    
    if t<=tau
      h_delay(t)=1;
  end
  if t>tau
      h_delay(t)=h_t(t-tau);
  end
   
    
    
end

plot(T,h_t);
hold on;
plot(T,h_sp_t,'r--');
hold on
plot (T,h_delay);



